#include "resourcesp.h"
#include <windows.h>
#include <commctrl.h>
#include <aygshell.h>

#ifdef SYSVOLUME_CPL_EXPORTS
#include "cpl.h"
#endif

#define MAX_LOADSTRING	100
#define MUTEX_NAME		_T("SYSTEM_VOLUME_SETTINGS")
#define MAX_RANGE		10
#define MAX_VOLUME		0xFFFF

HINSTANCE			g_hInst = NULL;
HWND				g_hwndMB = NULL;

int GetVolume()
{
	DWORD dwVolume;
	waveOutGetVolume(NULL, &dwVolume);
	dwVolume = max(LOWORD(dwVolume), HIWORD(dwVolume));
	return dwVolume * MAX_RANGE / MAX_VOLUME;
}

BOOL SetVolume(int nVolume)
{
	DWORD dwVolume;
	dwVolume = MAX_VOLUME * nVolume / MAX_RANGE;
	dwVolume = MAKELONG(dwVolume, dwVolume);
	waveOutSetVolume(NULL, dwVolume);
	return TRUE;
}

void MainOnInitDialog(HWND hDlg)
{	
	int nVolume, nRet;
	TCHAR szMin[MAX_LOADSTRING];
	TCHAR szMax[MAX_LOADSTRING];
	TCHAR szText[MAX_LOADSTRING];

	SHINITDLGINFO shidi;
	shidi.dwMask = SHIDIM_FLAGS;
	shidi.dwFlags = SHIDIF_SIZEDLGFULLSCREEN;
	shidi.hDlg = hDlg;
	SHInitDialog(&shidi);

	SHMENUBARINFO mbi = {0};
	mbi.cbSize = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hDlg;
	mbi.nToolBarId = IDR_MENU;
	mbi.hInstRes = g_hInst;
	if (SHCreateMenuBar(&mbi))
		g_hwndMB = mbi.hwndMB;

	(void)SendMessage(mbi.hwndMB, SHCMBM_OVERRIDEKEY, VK_TBACK, 
			MAKELPARAM(SHMBOF_NODEFAULT | SHMBOF_NOTIFY, SHMBOF_NODEFAULT | SHMBOF_NOTIFY));

	nVolume = GetVolume();
	LoadString(g_hInst, IDS_MIN, szMin, MAX_LOADSTRING);
	LoadString(g_hInst, IDS_MAX, szMax, MAX_LOADSTRING);

	for (int i = 0; i <= MAX_RANGE; i++) {
		if (i == 0) 
			nRet = SendMessage(GetDlgItem(hDlg, IDC_LIST_VOLUME), LB_ADDSTRING, 0, (LPARAM)szMin);
		else if (i == MAX_RANGE)
			nRet = SendMessage(GetDlgItem(hDlg, IDC_LIST_VOLUME), LB_ADDSTRING, 0, (LPARAM)szMax);
		else {
			wsprintf(szText, _T("%d"), i);
			nRet = SendMessage(GetDlgItem(hDlg, IDC_LIST_VOLUME), LB_ADDSTRING, 0, (LPARAM)szText);
		}

		if (nVolume == i) {
			SendMessage(GetDlgItem(hDlg, IDC_LIST_VOLUME), LB_SETCURSEL, nRet, 0);
		}
	}
}

BOOL MainOnNotify(HWND hDlg, NMHDR* pHdr)
{
	int nCount, nSel;
	if (pHdr->code != UDN_DELTAPOS)
		return FALSE;

	nCount = SendMessage(GetDlgItem(hDlg, IDC_LIST_VOLUME), LB_GETCOUNT, 0, 0);
	nSel = SendMessage(GetDlgItem(hDlg, IDC_LIST_VOLUME), LB_GETCURSEL, 0, 0);

	if (((NM_UPDOWN*)pHdr)->iDelta > 0) {
		nSel = min(nSel + 1, nCount - 1);
	}
	else if (((NM_UPDOWN*)pHdr)->iDelta < 0) {
		nSel = max(nSel - 1, 0);
	}
	SendMessage(GetDlgItem(hDlg, IDC_LIST_VOLUME), LB_SETCURSEL, nSel, 0);

	SetVolume(nSel);
	PlaySound(_T("\\Windows\\Ding.wav"), NULL, SND_FILENAME | SND_ASYNC);
	return TRUE;
}

BOOL CALLBACK MainDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	case WM_INITDIALOG:
		MainOnInitDialog(hDlg);
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDM_OK:
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		case IDC_LIST_VOLUME:
			if (HIWORD(wParam) == LBN_SELCHANGE) {
				int nSel = SendMessage(GetDlgItem(hDlg, IDC_LIST_VOLUME), LB_GETCURSEL, 0, 0);
				
				SetVolume(nSel);
				PlaySound(_T("\\Windows\\Ding.wav"), NULL, SND_FILENAME | SND_ASYNC);
			}
		}
		return FALSE;
	case WM_DESTROY:
		if (g_hwndMB) {
			CommandBar_Destroy(g_hwndMB);
			g_hwndMB = NULL;
		}
		return TRUE;
	case WM_NOTIFY:
		return MainOnNotify(hDlg, (NMHDR*)lParam);
	case WM_HOTKEY:
		if (VK_TBACK == HIWORD(lParam) && (0 != (MOD_KEYUP & LOWORD(lParam)))) {
			EndDialog(hDlg, IDCANCEL);
		}
	}
	return FALSE;
}

#ifdef SYSVOLUME_CPL_EXPORTS

BOOL WINAPI DllMain(HANDLE hInstance, DWORD dwReason, LPVOID lpvReserved)
{
	g_hInst = (HINSTANCE)hInstance;
	return TRUE;
}

extern "C"
__declspec(dllexport)
LONG WINAPI CPlApplet(HWND hwndCPL, UINT uMsg, LONG lParam1, LONG lParam2)
{
	LPNEWCPLINFO pNewCplInfo;
	HANDLE hMutex;

	switch (uMsg) {
	case CPL_INIT:
		return TRUE;
	case CPL_GETCOUNT:
		return 1;
	case CPL_NEWINQUIRE:
		if (lParam1 != 0)
			return 1;

		pNewCplInfo = (LPNEWCPLINFO)lParam2;
		pNewCplInfo->dwSize = (DWORD)sizeof(NEWCPLINFO);
		pNewCplInfo->dwFlags = 0;
		pNewCplInfo->dwHelpContext = 0;
		pNewCplInfo->lData = IDI_SYSVOLUME;
		pNewCplInfo->hIcon = LoadIcon(g_hInst, (LPCTSTR)MAKEINTRESOURCE(IDI_SYSVOLUME));
		pNewCplInfo->szHelpFile[0] = '\0';
		LoadString(g_hInst, IDS_APP_TITLE, pNewCplInfo->szName, 32);
		LoadString(g_hInst, IDS_APP_TITLE, pNewCplInfo->szInfo, 64);
		break;
	case CPL_DBLCLK:
		if (lParam1 != 0)
			return 1;

		hMutex = CreateMutex(NULL, NULL, MUTEX_NAME);
		if (GetLastError() == ERROR_ALREADY_EXISTS)
			return 1;
		
		DialogBox(g_hInst, MAKEINTRESOURCE(IDD_MAIN), hwndCPL, MainDlgProc);
		CloseHandle(hMutex);
		break;
	case CPL_STOP:
		break;
	case CPL_EXIT:
		break;
	}
	return 0;
}

#else

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	HANDLE hMutex = CreateMutex(NULL, NULL, MUTEX_NAME);
	if (GetLastError() == ERROR_ALREADY_EXISTS) {
		return FALSE;
	}

	g_hInst = hInstance;
	InitCommonControls();
	DialogBox(g_hInst, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDlgProc);
	return 0;
}

#endif // SYSVOLUME_CPL_EXPORTS
